/*
    include.h -- List of included files.
*/
/*
    Copyright (c) 1984, Taiichi Yuasa and Masami Hagiya.
    Copyright (c) 1990, Giuseppe Attardi.

    ECoLisp is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    See file '../Copyright' for full details.
*/


#ifdef __GNUC__
#define VOID void
#else
#define VOID char
#endif

#include "machines.h"

#include <stdio.h>
#ifndef __linux__
#define _BASE _base
#define _FILE _file
#else
#define _BASE _IO_read_base
#define _FILE _fileno
#endif

#include <stdarg.h>
#include <stdlib.h>
#include <setjmp.h>
#include <limits.h>
#include <ctype.h>

#ifdef unix

#include <sys/param.h>		/* includes <sys/signal.h> and <sys/types.h> */

#ifdef BSD
#include <sys/time.h>
#endif BSD

#ifdef SYSV

#ifndef MAXPATHLEN
#define MAXPATHLEN	PATH_MAX
#endif MAXPATHLEN

#include <signal.h>
#include <sys/types.h>

#endif SYSV
#endif unix

#include "object.h"

#ifdef MTCL
#include "critical.h"
#include "lwp.h"
#endif MTCL

#include "vs.h"
#include "bds.h"
#include "frame.h"
#include "external.h"
#include "lex.h"
#include "eval.h"
#include "cs.h"

/**********************************************************************/
